include 'Vram.inc'
include 'Chars.inc'

ext WRTVRM, RDVRM, LDIRVM, FILVRM
ext VVram_, RowFlags_, Status_
ext Chars, SpritePattern

VramTop equ Vram


; void InitVdp();
cseg
VdpValues:
    defb 16h,0e2h
    defb 0ffh,0ffh,0ffh,0ffh,0fbh,00h
    defb 0,224-24
    defb 20-2+1
ColorValues:
    defb 0,0
    defb 0,15
    defb 15,0
    defb 15,15
    defb 240,0
    defb 240,15
    defb 255,0
    defb 255,15
    defb 51,3
    defb 0,12
    defb 12,0
    defb 12,12
    defb 192,0
    defb 192,12
    defb 204,0
    defb 204,12
    ; defb 0,30h,03h,33h,0ch,3ch,0fh,3fh
    ; defb 15h,20h,02h,22h,08h,28h,0ah,2ah
InitVdp_: public InitVdp_
    push af | push hl | push de | push bc
        ld hl,VdpValues
        ld c,0
        ld b,11
        do
            ld a,(hl) | out (VdpPort+1),a
            inc hl
            ld a,c | or 80h | out (VdpPort+1),a
            rst 30h
            inc c
        dwnz

        xor a | out (VdpPort+1),a
        ld a,0c0h | out (VdpPort+1),a
        ld c,2
        do
            ld hl,ColorValues
            ld b,16*2
            do
                ld a,(hl) | inc hl
                out (VdpPort),a
            dwnz
            dec c
        while nz | wend
    pop bc | pop de | pop hl | pop af
ret

; void InitMonoChar(word vram, ptr<byte> p, byte count, byte color);
dseg
InitMonoChar_@Param3: public InitMonoChar_@Param3
    defb 0
cseg
InitMonoChar_: public InitMonoChar_
    push af | push hl | push de | push bc
        ld a,l | out (VdpPort+1),a
        ld a,h | or 40h | out (VdpPort+1),a
        ex de,hl
        do
            push bc
                ld c,CharHeight
                do
                    ld e,(hl) | inc hl
                    ld a,(InitMonoChar_@Param3)
                    ld d,a
                    ld b,4
                    do
                        bit 0,d
                        if nz
                            ld a,e
                        else
                            xor a
                        endif
                        out (VdpPort),a
                        srl d
                    dwnz
                    dec c
                while nz | wend
            pop bc
            dec c
        while nz | wend
    pop bc | pop de | pop hl | pop af
ret


; void InitColorChar(word vram, ptr<byte> p, byte count);
cseg
InitColorChar_: public InitColorChar_
    push af | push hl | push de | push bc
        ld a,l | out (VdpPort+1),a
        ld a,h | or 40h | out (VdpPort+1),a
        ex de,hl
        do
            ld b,CharHeight*4
            do
                ld a,(hl) | inc hl
                out (VdpPort),a
            dwnz
            dec c
        while nz | wend
    pop bc | pop de | pop hl | pop af
ret


; void ClearScreen();
cseg
ClearScreen_:
    public ClearScreen_
    push af | push hl | push bc
        ld hl,Vram_PatternName
        ld bc,VramHeight*VramRowSize
        xor a
        call FILVRM

        ld hl,Vram_SpriteAttribute
        ld bc,64
        ld a,0d0h
        call FILVRM
    pop bc | pop hl | pop af
ret


; word VramAddress(byte x, byte y);
VramAddress_: public VramAddress_
    push de
        ld l,e
        ld h,0
        add hl,hl ;*2
        add hl,hl ;*4
        add hl,hl ;*8
        add hl,hl ;*16
        add hl,hl ;*32
        add hl,hl ;*64
        add a,a
        ld e,a
        ld d,0
        add hl,de
        ld de,Vram
        add hl,de
    pop de
ret


; void VPut(word vram, byte c);
cseg
VPut_: public VPut_
    push af
    di
        ld a,l | out (VdpPort+1),a
        ld a,h | or 40h | out (VdpPort+1),a
        ld a,e
        out (VdpPort),a
        nop | nop | nop
        xor a
        out (VdpPort),a
    ei
    pop af
ret


; word PrintC(word vram, byte c);
cseg
PrintC_: public PrintC_
    ex af,af'
        ld a,e
        sub ' '
        call WRTVRM
    ex af,af'
    inc hl
    inc hl
ret
